% GASS for discrete problem
% update p_k directely
function [samples, Hbar, xbar] = GASS_dis(N, K, choices, M)
% N: # of samples
% K: # of iterations
% choices: choice of test function
% M: dimension of the test function

%gamma_k=1;  %stepsize
%alpha=1.002;  % sample size increasing parameter
D=41;  %number of discrete points at 1 dim
dist=0.5;  %distance between points
st=-10;  %start point
p_k = 1/D*ones(1,M*D);  
X_k_indx=multirnd1(p_k,M,N);
X_k=st+(X_k_indx-1)*dist;

stop=0;
k=1;
samples=zeros(K,1);
Hbar = zeros(K,1);
xbar = zeros(K,M);
Ntotal=0;


while (stop==0)&&(k<=K)
    %gamma_k=5/(k+100)^0.501; % stepsize in SA    
    gamma_k=0.1/k^0.05; % stepsize in SA
    Ntotal=Ntotal+N;
    samples(k) = Ntotal;
  
    switch choices
        case 1
            Hl=1e10;
            G=-rosenbrock(X_k)+Hl;
        case 2
            Hl=1e6;
            G =-tri(X_k)+Hl;
        case 3
            Hl=1e4;
            G=-griewank(X_k)+Hl;
        case 4
            Hl=0;
            G=shekel(X_k)+Hl;
        case 5
            Hl=0;
            G=-dejong5(X_k)+Hl;
        case 6
            Hl=1e10;
            G=-powel(X_k)+Hl;
        case 7
            Hl=1e6;
            G=-levy(X_k)+Hl;
        case 8 
            Hl=1e6;
            G=-rastrigin(X_k)+Hl;
        case 9
            Hl=1e6;
            G = -pinter(X_k)+Hl;
        case 10
            Hl=1e6;
            G = -sphere(X_k)+Hl;             
    end  % end switch
    [Hbar(k), indx] = max(G);
    xbar(k,:) = X_k(indx,:);
    clear X_k;
    if isnan(Hbar(k))==1  
        Hbar(k)=Hbar(k-1);
        xbar(k,:) =xbar(k-1,:);
        break
    end

    if k>2
    if Hbar(k-1)>max(G)     
        Hbar(k)=Hbar(k-1);
        xbar(k,:) =xbar(k-1,:);
    end 
    end
    
    
    
    %--use shape function---take the elite samples---
    rho=0.1;
    [G_sort, I_sort] = sort(G,'descend');   % sorted performances
    gm = G_sort(ceil(N*rho));
    %G_u=(G>=gm);
    G_u=(G>=gm).*(G);
    %r=((1e-5)+abs(0.1*Hbar(k))/log(1+k))^(-1);
    %r=1e-3;
    %r=1/max(abs(G));
    %G_u=(G>=gm).*exp(r*G);
    
    w_k=(G_u)/sum(G_u);

for j=1:M
    D1f_k(:,(j-1)*D+1:j*D)=(X_k_indx(:,j)*ones(1,D)==([1:D]'*ones(1,N))');
end
clear X_k_indx;     
for i=1:D*M
    if p_k(i)==0
        p_k_reci(i)=0;
    else
        p_k_reci(i)=1/p_k(i);
    end
end
    Df_k=(p_k_reci'*ones(1,N))'.*D1f_k; 
    grad_k=w_k'*Df_k;
    Hes_k_inv=zeros(D*M,D*M);
    for i=1:M
        Hes_k_inv((i-1)*D+1:i*D,(i-1)*D+1:i*D)=-(grad_k((i-1)*D+1:i*D)'*grad_k((i-1)*D+1:i*D)+1e-5.*eye(D))\diag(ones(1,D));
    end
    d_theta_k=-(Hes_k_inv*grad_k')';
    
    %d_theta_k=grad_k;
    
    %Hes_k=-(Df_k-ones(N,1)*mean(Df_k))'*(w_k*ones(1,D*M).*(Df_k-ones(N,1)*mean(Df_k)));
    %Hes_k=-grad_k'*grad_k;
    %d_theta_k=(-inv(Hes_k + 1e-10.*eye(D*M))*grad_k')';
    %d_theta_k=(-(Hes_k + 1e-10.*eye(D*M))\diag(ones(1,D*M))*grad_k')';
    %d_theta_k=(-Hes_k\diag(ones(1,D*M))*grad_k')';
    
    if norm(grad_k) < 1e-30
        fprintf('grad small! \n');
        stop=1; break;
    else
    % update the parameter using an SA iteration
    
    for j=1:M
        p_k((j-1)*D+1:j*D)=projsplx(p_k((j-1)*D+1:j*D)+gamma_k*d_theta_k((j-1)*D+1:j*D));
        %p_k_sum(j)=sum(p_k((j-1)*D+1:j*D));
    end
    %p_k
    %p_k_sum
   clear d_theta_k grad_k p_k_reci Hes_k_inv;
    %p_k_hat=zeros(1,D*M);    
%     for j=1:M
%         [p_max,indx_p]=max(d_theta_k((j-1)*D+1:j*D));
%         p_k_hat((j-1)*D+indx_p)=1;
%     end

%     for j=1:M
%         p_k_hat((j-1)*D+1:j*D)=d_theta_k((j-1)*D+1:j*D)/sum(d_theta_k((j-1)*D+1:j*D));
%     end
    
%     for j=1:M
%         p_k_hat((j-1)*D+1:j*D)=projsplx(p_k((j-1)*D+1:j*D)+5*gamma_k*d_theta_k((j-1)*D+1:j*D));
%     end

    %p_k=p_k+gamma_k*(p_k_hat-p_k);
      
    % generate new samples
%N=max(100,floor(k^0.502));
    
    X_k_indx=multirnd1(p_k,M,N);
    X_k=st+(X_k_indx-1)*dist;
    
    end  %end if
      
    k=k+1;    
    clear G G_u w_k grad_k D1f_k Df_k;
end %end while
Hbar=Hbar-Hl;
%p_k
for l=k:K
samples(l) = Ntotal;
Hbar(l)=Hbar(k-1);
xbar(l,:) =xbar(k-1,:);
%N=N*alpha;
%N=ceil(max(1000,(3/(2*10^5)*1/(1/k^1.5-1/(k+1)^1.5))^2));
Ntotal=Ntotal+N;
end