function [S_b,pi,P]=GASS_tsp(N,rho,A,traj)
% finds a good tsp tour via CE
% traj=0 - use node transitions
% traj=1 - use node placement
% theta: n*(n-1), doesn't include diagnal of P

[m,n]=size(A);
tol=0.005;
z=5;

kk=(1:n)';

% initial P

st=zeros(z,1);

Pold=zeros(n);
if (traj==0),
%P=ones(n)*1/(n-1);
%P=P-diag(diag(P));
%theta=ones(1,n*(n-1))*1/(n-1);
P=1./(A);
P=P-diag(diag(P));
P=P./(sum(P,2)*ones(1,n));
for i=1:n
    for j=1:n
        if j<i
        theta((i-1)*(n-1)+j)=P(i,j);
        end
        if j>i
        theta((i-1)*(n-1)+j-1)=P(i,j);   
        end
    end
end 

else
P=ones(n)*1/n;
end

count=1;
while max(max(abs(P-Pold)))>tol && count<80
gamma=1/count^0.05; % stepsize 

for i=1:N,
if traj==0,
	X(i,:)=gtsp0(P);
else
X(i,:)=gtsp1(P);
end
if(traj==0),
S(i)=stsp(X(i,:),A);
else

y=X(i,:);

for zi=1:n,
        ki=y(zi);
x(ki)=zi;
end

Y(i,:)=x;

S(i)=stsp(x,A);

end

end
[S,I]=sort(S);
g=floor(rho*N);
S_u=S(N)+0.01;
sum_S=g*S_u-sum(S(1:g));

if(traj==0),

for i=1:n,
	for j=1:n,
% portion of elite samples having a transition from i to j
                ss=0;
for k=1:g,
                ii=kk(X(I(k),:)==i);
                if(ii<n),
                    if(X(I(k),ii+1)==j),
ss=ss+1;
%ss=ss+S_u-S(k);
end
else
if(X(I(k),1)==j),
ss=ss+1;
%ss=ss+S_u-S(k);
end
end
end

		w(i,j)=ss/g;
        %w(i,j)=ss/sum_S;
        
end
end

else %traj==1, ie node placement

for i=1:n,
for j=1:n,

ss=0;
for k=1:g,
  ss=ss+(Y(I(k),i)==j);
end

w(i,j)=ss/g;

end
end

end

for i=1:n*(n-1)
    if theta(i)==0
        theta_reci(i)=0;
    else
        theta_reci(i)=1/theta(i);
    end
end
for i=1:n
    for j=1:n
        if j<i
        w_vec((i-1)*(n-1)+j)=w(i,j);
        end
        if j>i
        w_vec((i-1)*(n-1)+j-1)=w(i,j);   
        end
    end
end
grad=theta_reci.*w_vec;
for i=1:n
        Hes_inv((i-1)*(n-1)+1:i*(n-1),(i-1)*(n-1)+1:i*(n-1))=-(grad((i-1)*(n-1)+1:i*(n-1))'*grad((i-1)*(n-1)+1:i*(n-1))+1e-5.*eye(n-1))\diag(ones(1,n-1));
end
d_theta=-(Hes_inv*grad')';
%     for i=1:n*(n-1)
%     if grad(i)==0
%         grad_reci(i)=0;
%     else
%         grad_reci(i)=1/grad(i);
%     end
%     end
%    d_theta=-grad;
    for j=1:n
        theta((j-1)*(n-1)+1:j*(n-1))=projsplx(theta((j-1)*(n-1)+1:j*(n-1))+gamma*d_theta((j-1)*(n-1)+1:j*(n-1)));
        theta_sum(j)=sum(theta((j-1)*(n-1)+1:j*(n-1)));
    end
for i=1:n
    for j=1:n
        if (i==1 && j==1)
            P(i,j)=0;
        else
        if j<i
        P(i,j)=theta((i-1)*(n-1)+j);
        end
        if j>i
        P(i,j)=theta((i-1)*(n-1)+j-1);
        end
        end
    end
end
%sum(P,2)

st(1:(z-1))=st(2:z);
st(z)=S(g);
[count,S(g),S(1)]
if count==1
    S_b=S(1);
else
    S_o=S_b;
    S_b=min(S(1),S_o);
end
if (sum(st==st(z))==z),
break;
end
count=count+1;
end
if(traj==0)
pi=X(I(1),:);
else
pi=Y(I(1),:);
end
